# HOSN - Hybrid Online Social Network
_"Tweet beyond the cage of commercial  social networks"_

This repository contains an Android app, as a proof of concept for HOSN, builds on top of Twitter and provides users with additional means of privacy control.

## Synopsis
The idea of HOSNs is to combine a commercial online social network (COSN) and a privacy-preserving online social network (PPOSN) . 
That combination enables to utilize both the market penetration of COSNs and the anonymity of PPOSNs. 
The COSN serves as base network and provides the user base as well as the connectivity between these users. 
The PPOSN is established above, providing the users with means of communication beyond the knowledge of the provider of the COSN.
Simply put, the objective of HOSN is providing the users of COSNs with additional means of privacy control by establishing a PPOSN on top of the COSN.

### Third Party Services
Throughout this application we have used several third party services. For all the features od this application to works as expected we require that these third party sevices also function correctly. Below we mention list of all these services used

- Twitter API
In order access Twitter via third party app we need to request acces via twitter developer account.
After the request has been approved unique keys, these keys have been used in our app in these file.

HOSN-app\app\src\providers\twitter-api\twitter-api.ts

- Firebase
In order to interact with the twitter API we need a hosting URL. Firebase provides us with hosting URL. Once the app is hosted on firebase it generate configuration keys. These keys are found in the below file 

HOSN-app\app\src\providers\auth\auth.ts

- IPFS Infura

HOSN-app\app\src\providers\p2p-storage-ipfs\p2p-storage-ipfs.ts

- OpenPGP
Although generation of PGP keys done offline, Publishing the same public key requires the PGP server to be up and running. Please find the URL in the file below.

HOSN-app\app\src\providers\pgp-key-server\pgp-key-server.ts

- GUN
GUN is hosted on heroku and an URL is generated. Which is unique to our application. This URL configured in file below

HOSN-app\app\src\providers\p2p-database-gun\p2p-database-gun.ts

- Twit is the client we use to interact with the Twitter API. All requests to the Twitter API are done by Twit client


### References
[1] [Wainakh et al. (2019) Tweet beyond the Cage: A Hybrid Solution for the Privacy Dilemma in Online Social Networks](https://globecom2019.ieee-globecom.org/)

[2] [RTG Privacy and Trust for Mobile Users - Privacy Protection via Hybrid Social Networks](https://www.informatik.tu-darmstadt.de/privacy-trust/research_5/research_area_b__privacy_and_trust_in_social_networksresearch_area_b__privacy_and_trust_in_social_networks/b__2_privacy_protection_via_hybrid_social_networks/index.en.jsp)

## Authors

- __Aidmar Wainakh__ - _guidance and suggestions during development_

- __Jörg Daubert__ - _guidance and suggestions during development_

- __Tim Grube__ - _concept development_

- __Carsten Porth__ - _development of first prototype within his Master Thesis_

## Contact
Aidmar Wainakh (<wainakh@tk.tu-darmstadt.de>)